// SoftwareSerial example by Tom Igoe
// based on examples by David Mellis and Heather Dewey-Hagborg

#include <SoftwareSerial.h>  // Cu̓

#define rxPin 4
#define txPin 3
#define ledPin 13

byte pinState = 0;  // LED̏

// VȃVA|[gݒ
SoftwareSerial mySerial =  SoftwareSerial(rxPin, txPin);

void setup()  {
  pinMode(rxPin, INPUT);           // BTVAM
  pinMode(txPin, OUTPUT);          // BTVAM
  pinMode(ledPin, OUTPUT);         // ԊOLED
  mySerial.begin(9600);            // BTXs[hݒ
  
  Serial.begin(9600);              // VAXs[hݒ
}

void loop() {
  unsigned long nSpeed = 3;
  unsigned long nTurn  = 0;
  unsigned long nBand  = 3;

  char someChar = mySerial.read(); // M҂
  mySerial.print(someChar);        // 𑗐MiGR[obNj
  
  nSpeed = (unsigned long)(someChar >> 4) & 0x03;
  nTurn  = (unsigned long)(someChar >> 2) & 0x03;
  nBand  = (unsigned long)(someChar     ) & 0x03;

  send_Forward( nSpeed, nTurn, nBand ); // ԊOLEDőM
   
  Serial.println( someChar, HEX );  // VAփOo
}

//----------------------------------------------------------------------
void  send_Forward( unsigned long _speed, unsigned long _turn, unsigned long _band )
{
  send_start();
  switch( _speed ){
  case  1:
    send_0();
    send_1();
    break;
  case  2:
    send_1();
    send_0();
    break;
  case  3:
    send_1();
    send_1();
    break;
  default:
    send_0();
    send_0();
    break;
  }
  switch( _turn ){
  case  1:
    send_0();
    send_1();
    break;
  case  2:
    send_1();
    send_0();
    break;
  case  3:
    send_1();
    send_1();
    break;
  default:
    send_0();
    send_0();
    break;
  }
  switch( _band ){
  case  1:
    send_0();
    send_1();
    break;
  case  2:
    send_1();
    send_0();
    break;
  case  3:
    send_1();
    send_1();
    break;
  default:
    send_0();
    send_0();
    break;
  }
  send_stop();
}
//----------------------------------------------------------------------
void  send_start()
{
    send_signal(ledPin,1000,HIGH);
}
void  send_1()
{
    send_signal(ledPin,1000,HIGH);
    send_signal(ledPin,500,LOW);
}
void  send_0()
{
    send_signal(ledPin,500,HIGH);
    send_signal(ledPin,500,LOW);
}
void  send_stop()
{
    send_signal(ledPin,500,HIGH);
    send_signal(ledPin,500,LOW);
}
//----------------------------------------------------------------------
void  send_signal( unsigned int port, unsigned long len, unsigned int sw )
{
    unsigned long us = micros();
    do {
      digitalWrite(port, sw);
      delayMicroseconds(8);  // LAg38kHzON/OFF悤Ԓ
      digitalWrite(port, 0);
      delayMicroseconds(7);
    } while (long(us + len - micros()) > 0); // MԂɒB܂Ń[v
}
